<?php

/**
 * inf_traza_cargos actions.
 *
 * @package    nomina
 * @subpackage inf_traza_cargos
 * @author     Manuel Enrique Paredes Lopez
 * @email       mparedes@sofhouse.net
 * @fecha       11/12/19
 * @version    SVN: $Id: actions.class.php 23810 2009-11-12 11:07:44Z Kris.Wallsmith $
 */
class inf_traza_cargosActions extends sfActions {

    /**
     * Executes list action
     *
     * @param sfRequest $request A request object
     */
    public function executeList(sfWebRequest $request) {

        //Revisar que sea post
        //$this->forward404Unless($request->isMethod('post'));
        //Guardar los parametros del request en el log
        $this->logMessage("---BEGIN Logging request");
        foreach ($request->getPostParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("--------------------------------------------------*  Ip: " . $_SERVER['REMOTE_ADDR']);
        foreach ($request->getGetParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("---END Logging request");

        /*
         * Paginacion
         */
        if (isset($request['_startRow'])) {
            $rowStart = $request['_startRow'];
        } else {
            $rowStart = 0;
        }

        if (isset($request['_endRow'])) {
            $rowEnd = $request['_endRow'];
        } else {
            $rowEnd = 75;
        }
        //ordenar consulta
        if (isset($request['_sortBy'])) {
            $sortBy = " Order by " . $request['_sortBy'];
        } else {
            $sortBy = 'order by num_doc';
        }


        /*
         * Manejo de errores
         */
        try {
            /*
             * Variables obligatorias
             */
            //LISTO
            $id_anhos = $request['id_anhos'];
            //LISTO
            $id_meses = $request['id_meses'];
            
            

            /*
             * Variables opcionales
             */
            //funcionario listo
            if (isset($request['num_doc'])) {
                $whereFuncionarioNumDoc = " AND tab0.num_doc = " . $request['num_doc'];
            } else {
                $whereFuncionarioNumDoc = ' ';
            }
            //funcionario listo
            if (isset($request['id_tipo_doc'])) {
                $whereFuncionarioTipoDoc = " AND tab0.id_tipo_doc = " . $request['id_tipo_doc'];
            } else {
                $whereFuncionarioTipoDoc = ' ';
            }
            //estado listo
            if (isset($request['estado']) && $request['estado'] == 'true') {
                $whereEstado = " AND tab0.estado = 1 ";
            } else if (isset($request['estado']) && $request['estado'] == '0') {
                $whereEstado = " AND tab0.estado = 0 ";
            }else if(isset($request['estado'])&&$request['estado']=='false') {
                $whereEstado = " AND tab0.estado IN (0,1)";
            }
            else {
                $whereEstado = ' ';
            }
            //CARGO listo
            if(isset($request['id_dp'])){
                                
                $whereCargo ="and tab0.id_dp =".$request['id_dp'];
            }else{
                $whereCargo="";
            }
            
            
            
            
             
            //CENTRO DE OPERACION LISTO
            if (isset($request['id_cen_op'])) {
                $whereCentroOperacion = " AND tab0.id_cen_op = " . $request['id_cen_op'];
            } else {
                $whereCentroOperacion = ' ';
            }

            //AREA LISTO
            if (isset($request['id_area'])) {
                $whereArea = " AND tab0.id_ea = " . $request['id_area'];
            } else {
                $whereArea = ' ';
            }
            
            //PROFESION listo
            if (isset($request['profesion'])) {
                $whereProfesion = " AND tab0.descripcion LIKE %".$request['profesion'];
            } else {
                $whereProfesion = ' ';
            }


            //COMPONENTE ESCALA
            if (isset($request['id_com_esc'])) {
                $whereCompEsc = " AND tab0.id_com_esc = " . $request['id_com_esc'];
            } else {
                $whereCompEsc = ' ';
            }
            
            
            
            
            
            
            
            
            

            //sentencia sql
            $sql = <<<EOD
ALTER SESSION SET NLS_DATE_FORMAT = "YYYY-MM-DD"
EOD;
            //ejecuta y obtiene el resultado del sql
            CN_TABLE::executeSQL($sql);


            /**
             * Consulta de debitos pendientes de pago
             * Solo debitos con titulos de canon y con tipo de tasa registrada
             */
            $consulta_sql = <<<EOD
select
dat.id_tipo_doc,
dat.tipo_documento,
dat.num_doc,
dat.primer_apellido,
dat.segundo_apellido,
dat.primer_nombre,
dat.segundo_nombre,
dat.nombre_apellido,
nom.fecha_nombra,
dat.sexo,
case when dat.sexo = 1 then 'FEMENINO' else 'MASCULINO' end as genero,
nom.fecha_ingreso,
nom.estado,
nom.fecha_retiro,
case 
when tipest.id_tipo_estudio is not null then tipest.descripcion
when titbas.id_titulo_basica is not null then titbas.descripcion
else null end as nivel_academico,
dp.componente as cargo,
dp.centro as centro_func,
dp.area as area_func,
dp.id_ea,
dp.id_cen_op,
tab5.id_anhos,
tab5.id_meses,
tab5.id_dp,
tab6.descripcion as descripcion_formacion,
dp.id_com_esc
from no_datos_funcionario_v dat
left join no_nombramiento_v nom
on nom.num_doc = dat.num_doc
and nom.id_tipo_doc = dat.id_tipo_doc
    
left join (
    SELECT
    aut.*,
    ROW_NUMBER() OVER (
        partition by aut.num_doc
        ORDER BY aut.num_doc, aut.id_anhos desc, aut.id_meses desc
    ) AS rnn
    from no_estado_func_v aut
)tab5
on dat.id_tipo_doc = tab5.id_tipo_doc and dat.num_doc = tab5.num_doc


left join NO_DP_V dp
on dp.id_dp = tab5.id_dp

left join (
    SELECT
    aut.*,
    ROW_NUMBER() OVER (
        partition by aut.num_doc
        ORDER BY aut.num_doc, aut.fecha_fin desc
    ) AS rn
    from formacion_superior aut
)tab6
on dat.id_tipo_doc = tab6.id_tipo_doc and dat.num_doc = tab6.num_doc
and tab6.rn = 1

left join tipo_estudio tipest
on tipest.id_tipo_estudio = tab6.id_tipo_estudio

left join tipo_titulo_basica titbas
on titbas.id_titulo_basica = dat.id_titulo_basica    
EOD;

            /*
             * Sql que trae los resultados
             * por los filtros, para totalizar las filas
             */
            $sql = <<<EOD
select count(*) as count from (

select 
tab0.*
from(
    
    $consulta_sql

)tab0
                    
where 
1=1
and tab0.id_anhos=$id_anhos
and tab0.id_meses = $id_meses
$whereFuncionarioNumDoc
$whereFuncionarioTipoDoc
$whereEstado
$whereCargo
$whereCentroOperacion
$whereArea
$whereProfesion
$whereCompEsc  

                    
)
EOD;

            $total_record_count = CN_TABLE::executeSQL($sql);
            $total_record_count = $total_record_count[0]["count"];


            //obtener el listado de recaudos
            $sql = <<<EOD
SELECT * FROM ( SELECT row_.*, ROWNUM rownum_ FROM (

select 
tab0.*
from(
    
    $consulta_sql

)tab0
                    
where 
1=1
and tab0.id_anhos=$id_anhos
and tab0.id_meses = $id_meses
$whereFuncionarioNumDoc
$whereFuncionarioTipoDoc
$whereEstado
$whereCargo
$whereCentroOperacion
$whereArea
$whereProfesion
$whereCompEsc       
$sortBy
          
) row_ WHERE ROWNUM <=  $rowEnd   ) where rownum_ >  $rowStart
EOD;
            //ejecuta y obtiene el resultado del sql
            $resultado = CN_TABLE::executeSQL($sql);


            $this->totalRows = $total_record_count;
            $this->startRow = $rowStart;
            $this->endRow = $rowStart + count($resultado);
            $this->list_data = $resultado;
            $this->logMessage("[inf_traza_cargos] Consulta exitosa.");
        } catch (Exception $e) {

            $this->status = 1;
            $this->totalRows = 0;
            $this->startRow = 0;
            $this->endRow = 0;
            $this->list_data = array();
            $this->logMessage("ERROR!!!");
            $this->logMessage($e->getMessage());
        }
    }

}
